{% extends "base.html" %}
{% load i18n crispy_forms_tags %}
{% block title %}{% translate "artefact"|capfirst %}{% endblock %}
{% block content %}
  <style>
    #preview-div {
      display: none;
    }

    #canvas {
      display: none;
    }

    .btn-circle {
      display: block;
      position: relative;
      margin-left: auto;
      margin-right: auto;
      bottom: 80px;
      width: 70px;
      height: 70px;
      border-radius: 35px;
      font-size: 2.2rem;
      line-height: 1.33;
    }

  </style>


  <div class="row mt-2">
    <div class="col-12">
      <h1 class="text-center"><i class="bi bi-upc"></i> {{ artefact.rescue_number}}</h1>
      <h4 class="text-center">{{ artefact.name }}</h4>
    </div>
  </div>
  <div class="row mt-3" id="camera-div">
    <div class="col-12">
      <div class="camera w-75">
        <video id="video" class="img-fluid">Video stream not available.</video>
        <button id="startbutton" type="button" class="btn btn-light btn-circle"><i class="bi bi-circle-fill" style="color: red;"></i></button>
      </div>
    </div>
  </div>
  <div class="row mt-3" id="preview-div">
    <div class="col-12">
      <canvas id="canvas"> </canvas>
      <div class="output w-75">
        <img id="photo" class="img-fluid" alt="The screen capture will appear in this box." />
        <button id="restartbutton" type="button" class="btn btn-primary btn-circle"><i class="bi bi-arrow-clockwise" style="color: whitesmoke;"></i></button>
      </div>
    </div>
  </div>
  <div class="row">
    <div class="col-12">
      <form method="post" enctype="multipart/form-data">
        {{ form|crispy }}
        {% csrf_token %}
        <button type="submit" class="btn btn-primary">Submit</button>
      </form>
    </div>
  </div>
{% endblock %}

{% block modal %}

{% endblock modal %}

{% block inline_javascript %}
<script>
  const width = 2592; // We will scale the photo width to this
  let height = 0; // This will be computed based on the input stream

  // |streaming| indicates whether or not we're currently streaming
  // video from the camera. Obviously, we start at false.

  let streaming = false;

  // The various HTML elements we need to configure or control. These
  // will be set by the startup() function.

  let video = null;
  let canvas = null;
  let photo = null;
  let startbutton = null;
  let restartbutton = null;
  let camera = null;
  let preview = null;

  function showViewLiveResultButton() {
    if (window.self !== window.top) {
      // Ensure that if our document is in a frame, we get the user
      // to first open it in its own tab or window. Otherwise, it
      // won't be able to request permission for camera access.
      document.querySelector(".contentarea").remove();
      const button = document.createElement("button");
      button.textContent = "View live result of the example code above";
      document.body.append(button);
      button.addEventListener("click", () => window.open(location.href));
      return true;
    }
    return false;
  }

  function startup() {
    if (showViewLiveResultButton()) {
      return;
    }
    video = document.getElementById("video");
    canvas = document.getElementById("canvas");
    photo = document.getElementById("photo");
    startbutton = document.getElementById("startbutton");
    restartbutton = document.getElementById("restartbutton");
    camera = document.getElementById("camera-div");
    preview = document.getElementById("preview-div");

    navigator.mediaDevices
      .getUserMedia({ video: true, audio: false })
      .then((stream) => {
        video.srcObject = stream;
        video.play();
      })
      .catch((err) => {
        console.error(`An error occurred: ${err}`);
      });

    video.addEventListener(
      "canplay",
      (ev) => {
        if (!streaming) {
          height = video.videoHeight / (video.videoWidth / width);

          // Firefox currently has a bug where the height can't be read from
          // the video, so we will make assumptions if this happens.

          if (isNaN(height)) {
            height = width / (4 / 3);
          }

          video.setAttribute("width", width);
          video.setAttribute("height", height);
          canvas.setAttribute("width", width);
          canvas.setAttribute("height", height);
          streaming = true;
        }
      },
      false
    );

    startbutton.addEventListener(
      "click",
      (ev) => {
        takepicture();
        ev.preventDefault();
      },
      false
    );

    restartbutton.addEventListener(
      "click",
      (ev) => {
        clearphoto();
        camera.style.display = 'block';
        preview.style.display = 'none';
        ev.preventDefault();
      },
      false
    );

    clearphoto();
  }

  // Fill the photo with an indication that none has been
  // captured.

  function clearphoto() {
    const context = canvas.getContext("2d");
    context.fillStyle = "#AAA";
    context.fillRect(0, 0, canvas.width, canvas.height);

    const data = canvas.toDataURL("image/png");
    photo.setAttribute("src", data);
  }

  // Capture a photo by fetching the current contents of the video
  // and drawing it into a canvas, then converting that to a PNG
  // format data URL. By drawing it on an offscreen canvas and then
  // drawing that to the screen, we can change its size and/or apply
  // other changes before drawing it.

  function takepicture() {
    const context = canvas.getContext("2d");
    const camera = document.getElementById("camera-div");
    const preview = document.getElementById("preview-div");
    const image = document.getElementById("id_image");
    if (width && height) {
      canvas.width = width;
      canvas.height = height;
      context.drawImage(video, 0, 0, width, height);

      const data = canvas.toDataURL("image/png");
      photo.setAttribute("src", data);
      // image.value = data;
      camera.style.display = 'none';
      preview.style.display = 'block';
    } else {
      clearphoto();
      camera.style.display = 'block';
      preview.style.display = 'none';
    }
  }

  // Set up our event listener to run the startup process
  // once loading is complete.
  window.addEventListener("DOMContentLoaded", startup, false);

</script>
{% endblock %}
